﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using SciLeague.TaskService.Data;

namespace SciLeague.TaskService.Migrations
{
    [DbContext(typeof(SciLeagueTaskContext))]
    partial class SciLeagueTaskContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Relational:MaxIdentifierLength", 64)
                .HasAnnotation("ProductVersion", "5.0.6");

            modelBuilder.Entity("SciLeague.TaskService.Models.Choice", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("Answer")
                        .HasColumnType("longtext");

                    b.Property<bool>("IsItTheCorrectAnswer")
                        .HasColumnType("tinyint(1)");

                    b.Property<int>("MultipleChoiceTaskId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("MultipleChoiceTaskId");

                    b.ToTable("Choice");
                });

            modelBuilder.Entity("SciLeague.TaskService.Models.ContributionMultiChoiceTask", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<int>("AttempsNeeded")
                        .HasColumnType("int");

                    b.Property<bool>("CorrectChoiceAnswered")
                        .HasColumnType("tinyint(1)");

                    b.Property<int>("PlayerTasksID")
                        .HasColumnType("int");

                    b.Property<int>("PointsConquered")
                        .HasColumnType("int");

                    b.Property<int>("SelectedChoiceID")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.ToTable("ContributionMultiChoiceTask");
                });

            modelBuilder.Entity("SciLeague.TaskService.Models.MultipleChoiceTask", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("Body")
                        .HasColumnType("longtext");

                    b.Property<bool>("DoWeKnowCorrectAnswer")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("Question")
                        .HasColumnType("longtext");

                    b.Property<int>("TaskId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("TaskId");

                    b.ToTable("MultipleChoiceTask");
                });

            modelBuilder.Entity("SciLeague.TaskService.Models.PlayerTasks", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("CreationDate")
                        .HasColumnType("longtext");

                    b.Property<int>("TaskId")
                        .HasColumnType("int");

                    b.Property<string>("Username")
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.ToTable("PlayerTasks");
                });

            modelBuilder.Entity("SciLeague.TaskService.Models.Task", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("CreationDate")
                        .HasColumnType("longtext");

                    b.Property<string>("CreatorUsername")
                        .HasColumnType("longtext");

                    b.Property<string>("Difficulty")
                        .HasColumnType("longtext");

                    b.Property<int>("Points")
                        .HasColumnType("int");

                    b.Property<string>("Type")
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.ToTable("Task");
                });

            modelBuilder.Entity("SciLeague.TaskService.Models.Choice", b =>
                {
                    b.HasOne("SciLeague.TaskService.Models.MultipleChoiceTask", "MultipleChoiceTask")
                        .WithMany()
                        .HasForeignKey("MultipleChoiceTaskId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("MultipleChoiceTask");
                });

            modelBuilder.Entity("SciLeague.TaskService.Models.MultipleChoiceTask", b =>
                {
                    b.HasOne("SciLeague.TaskService.Models.Task", "Task")
                        .WithMany()
                        .HasForeignKey("TaskId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Task");
                });
#pragma warning restore 612, 618
        }
    }
}
